Note1
This is a test page to
demonstrate the MASTERTOPAGE
command. Click on the RETURN
button to delete this page and
return to the page you were on.
Button1
/* RETURN */
pg = currentpage()
call return()
call delete(pg)
Test master
#(bes
W/* Toggle name of object on this page between 'Button1' and 'First button'. */
btn   = searchname(':','Button1')
found = 0
if length(btn) > 0 then do
   if getpage(btn) == currentpage() then do
      newname = 'First button'
      found   = 1
      end
   end
if found == 0 then do
   btn = searchname(':', 'First button')
   if length(btn) > 0 then do
      if getpage(btn) == currentpage() then do
         newname = 'Button1'
         found   = 1
         end
      end
   end
if found == 1 then
   say "The old button name was" setname(btn, newname)
   say "Couldn't find the button."
ChangeButtonName
/* Toggle name of this page between 'setname' and 'modified setname'. */
oldname = getname(':')
found   = 1
if oldname == 'setname' then do
   newname = 'modified setname'
   end
else do
   if oldname == 'modified setname' then do
      newname = 'setname'
      end
   else
      found = 0
   end
if found == 1 then
   say 'Old page name:' setname(':', newname)
   say 'This macro is meant for the "setname" page only.'
ChangePageName
5/* Delete everything on the current page, the Bin, and the page. */
 * Build a list of all the buttons on Page 1 which refer to the
 * page we're about to delete, so we can restore their actions later.
pagenum = getpage(":")
pagename = getname(":")
list = searchname("1:", "Section List")
fixitems = ""
do i=1 to totalelements(list)
   item = list"/"i
   if getaction(item)="gopage" & getactiontext(item)=pagename then
      fixitems = fixitems item
call clonepage(':', sequencenumber(":") + 1)
n = numelements(':')
do i = 1 to n
   ob = objectnumber(':', 1)
   if gettype(ob) == 'List' then do
      ln = numelements(ob)
      do j = 1 to n
         call delete(objectnumber(ob, j))
         end
      end
   call delete(ob)
   call refreshpage()
   end
call delete('0:')
call delete(':')
 * When a page is deleted, all objects whose actions are to go to that
 * page, have their actions reset to "no action".
 * So we now have to fix them.
do while fixitems ~= ""
   parse var fixitems item fixitems
   call setactionpage(item, pagenum)
DeleteStuff
/* FindAction - say action type of object clicked on by user */
prompt = 'Click to find out the action of an object on this page...'
obj    = GetObject(prompt)
if length(obj) == 0 then
   say 'This macro only works on objects.'
else do
   type = gettype(obj)
   if type == 'Page' || type == 'Bin' || type == 'Item' then
      say 'This macro only works on objects.'
   else
      say 'Action type is:' getaction(obj)
   end
FindAction
/* FindActionText - give action text of object clicked on by user */
prompt = 'Click to find out the action of an object on this page...'
obj    = GetObject(prompt)
if length(obj) == 0 then
   say 'This macro only works on objects.'
else do
   type = gettype(obj)
   if type == 'Page' || type == 'Bin' || type == 'Item' then
      say 'This macro only works on objects.'
   else
      text = getactiontext(obj)
      if length(text) > 0 then
         say 'Action text:' '0a'X ' ' text
      else
         say 'Action text: none'
   end
FindActionText
/* RelocateItem - moves Initiator() item from
   'reloc list 1' to 'reloc list 2' or vice versa.
L1 = searchname(':','reloc list 1')
L2 = searchname(':','reloc list 2')
it = initiator()
   if length(it) > 0 then if gettype(it) == 'Item' then break
   say 'This macro must be launched from a list item.'
   EXIT
   end
plist = parent(it)
if plist == L1 then
   call relocate(it, L2)
else if plist == L2 then
   call relocate(it, L1)
   say "Use this macro with the two lists on the `relocate' page."
RelocateItem
/* Relocate object - moves 'reloc button' from 'reloc group' to the current
   page or back again.
call interactive(0)
init = initiator()
if length(init) == 0 then do
   say 'This macro must be launched from an object.'
   EXIT
   end
par = parent(init)
grp = 'reloc group'()
call setbackground(grp,-1)
if par == grp then
   call relocate(init, ':')
else do
   call relocate(init, grp)
   call setbackground(grp,5)
   end
RelocateObject
^/* CloneItem - clones Initiator() item from
   'clone list 1' to 'clone list 2' or vice versa.
list1 = searchname(':','clone list 1')
list2 = searchname(':','clone list 2')
init = initiator()
launch_ok = 1
if length(init) == 0 then launch_ok = 0
else if gettype(init) ~= 'Item' then launch_ok = 0
if launch_ok == 0 then do
   say 'This macro must be launched from a list item.'
   EXIT
   end
plist = parent(init)
if plist == list1 then call clone(init, list2)
else do
   if plist == list2 then call clone(init, list1)
   else say 'Use this macro with the two lists on the "clone" page.'
   end
	CloneItem
/* Clone object - clones 'clone button' to 'clone group', renames it
   'cloned button', and repositions it 10 pixels right and 5 lines up from
   the group's top left, unless that would be less than 0, in which case it
   repositions below and to the right of the bottom left.
init = initiator()
if length(init) == 0 then do
   say 'This macro must be launched from an object.'
   EXIT
   end
grp = searchname(':','clone group')
if length(grp) > 0 then do
   new = clone(init, grp)
   call setname(new, 'cloned button')
   left = getleft(grp) + 100
   top  = gettop(grp) - 5
   if top < 0 || left > getwidth(':') then top = top + getheight(grp) + 10
   call setposition(new, left, top)
   end
CloneObject
/* ListCurrentPage   List the objects on this page by number and name */
ob = objectnumber(':',1)
pg = currentpage()
do while getpage(ob) == pg
   say ob getname(ob)
   ob = getnext(ob)
   if length(ob) == 0 then EXIT     /* This happens if on last page */
   end
ListCurrentPage
O/* LastPage - call last page of HyperBook */
call callpage(numpages() || ':')
LastPage
b/* Select object by clicking */
y = getclickrow(arg(1))
x = getcolumn()
return getobjectat(x,y)
GetObject(prompt)
x/* Returns the text used by the setaction buttons */
return 'b=initiator(); call setbackground(b, 9-getbackground(b))'
getBGtext(void)
a/* run as a macro the text of the initiating button */
interpret readnotetext(initiator(),0,-1)
ExecuteText()
/* FindPage - The action for all the items in the lists on the index page
   is to run this macro. It finds the page whose title is the same as the
   item text, then visits the page with callpage().
nm = getitemtext(initiator())
pn = 2
do until getname(pg) = nm
   pg = searchpagename(objectnumber('', pn + 1), nm)
   if pg = '' then EXIT
   pn = sequencenumber(pg)
   end
call callpage(pg)
FindPage()
/* ListSectionContents - activated by button on page 1 of this book */
cr    = '0a'X
list  = searchname(':', 'Section list')
item  = selectitem(list, 'Click on a section name in the list')
actxt = getactiontext(item)
text  = cr || '  Contents of `' || getitemtext(item) || ''' section  ' || cr || cr
start = sequencenumber(searchpagename(':', actxt))
item  = getnext(item)
if length(item) > 0 then
   stop = sequencenumber(searchpagename('', getactiontext(item))) - 1
   stop = numpages()
left = 1
do i = start to stop
   name = getname(objectnumber('', i))
   if left then
      text = text '  ' left(name, 20)
   else do
      text = text name '  ' cr
      end
   left = 1 - left
   end
if left == 0 then text = text || cr
call inform(text)
List section contents
/* This page entry macro is used only to assign "hdat:" to its proper
   place when this hyperbook is first loaded. After that it uses the
   visibility of the "AssignInfo" note as a flag meaning "Don't redo
   the assign". Change this macro as needed to use the ARexx hyperbook
   in different environments.
   If you need to save this hyperbook for some reason, make sure the
   AssignInfo note is invisible at the time.
if sequencenumber(':') = 1 then do
   note = searchname(':','AssignInfo')
   if length(note) > 0 then do
      if ~getvisibility(note) then do
         address command "assign hdat: HB_Samples:hbk"
         call setvisibility(note, 1)
         end
      end
   end
PageEntryMacro
/* INTERACTIVE demo
   This is called from the page about the Interactive() command. The items
   in the first half of the list on that page are changed to a different
   color. Because interactive mode is on, each is refreshed separately,
   which is rather slow and messy. The bottom half of the list is processed
   in the same way, but with interactive mode off, so the refresh is not
   done until after the macro terminates.
list = 'interactive list'()
n    = numelements(list)
do i = 1 to 5
   item = objectnumber(list, i)
   call setitemcolor(item, 3 - getitemcolor(item))
   end
call interactive(0)
do i = 6 to n
   item = objectnumber(list, i)
   call setitemcolor(item, 3 - getitemcolor(item))
INTERACTIVE demo
Note1
HML Functions
The sections listed at right
split the HML ARexx
functions into groups (by
color) and subgroups (by
line). To go to the first
page of any section, click
on its name. To see the
functions documented in a
given section, click on the
`List Section Contents'
button.
"Section list"
	HyperBook
Navigation
Main control panel
General operations
Page creation
Master pages
Page files
Page editing
Object creation
Object editing
Actions
Note and button text
Items and Lists
Searches
User input
Text editing
Printing
Data display
Language support
Button1
COMMAND INDEX
Button2
Sections
Button3
LIST SECTION
CONTENTS
"AssignInfo"
id=inputstring("Enter hdat: directory","HB_Samples:");if length(d)>0 then address command "assign hdat:" d
Button4
ABOUT THIS
HYPERBOOK
"ARexx Commands"
"Message from AHA!"
The pages of this hyperbook
 describe and illustrate each of the 137 HML
functions. Many of the programming examples, while not necessarily useful in
themselves, are sufficiently detailed to give a good idea of not only how
but also 
 a particular function might be used.
Knowledge of ARexx
 is needed for full understanding of the sample code.
You will also need to know how HML `objnums' work (consult your owner's
manual), and to be familiar with using HyperBook interactively.
HML does not duplicate the interactive capabilities of HyperBook
some areas it is more powerful, in others less. The design goal has been to
make it useful in as many typical applications as possible. If HML lacks a
capability you can't do without, don't suffer in silence. Write to us
explaining the problem, and we'll try to address it in a future release.
"About this hyperbook"
List1
activate
appenditem
beginprompt
bigpanel
callpage
	clearlist
	cleartext
clone
	clonepage
controlpanel
createbutton
creategroup
createlist
createnote
createpage
currentpage
delete
deletemaster
deletetext
edittext
	endprompt
explode
filerequest
formattext
	getaction
getactiontext
getbackground
	getborder
getclickrow
	getcolumn
getgroupdepth
	getheight
getitemcolor
getitemtext
getleft
List2
getname
getnext
getnextsib
getobjectat
getpage
getpagecolors
getpagelace
getpagergb
getprintwidth
getresponse
	getshadow
gettop
gettype
getvisibility
getwidth
gotopage
hyperbookname
hyperbooktoback
hyperbooktofront
inform
	initiator
	inputform
inputobject
	inputpage
inputstring
insertitem
inserttext
interactive
ismacro
ismasterpage
listheight
listscroll
loadhyperbook
loadpage
loadtext
List3
mastertopage
	mergepage
moveitem
	movemacro
nextpage
numelements
numpages
objectnumber
objecttoback
objecttofront
pagedim
pagetomaster
parent
pause
prevpage
	printpage
quithyperbook
readnotetext
refreshlist
refreshpage
relocate
replacetext
return
savehyperbook
savemoretext
savepage
savetext
scale
scaletosize
searchitems
searchname
searchnote
searchpagename
searchstart
List4
searchtext
selectitem
sequencenumber
setactiondos
setactionlink
setactionmacro
setactionnone
setactionpage
setactionpic
setactionread
setactionrexx
setactionshow
setbackground
	setborder
setitemcolor
setitemtext
setname
setpagecolors
setpagelace
setpagenumber
setpagergb
setposition
	setshadow
setvisibility
shadowstyle
showpic
showtext
showtextrange
sortlist
	tinypanel
totalelements
wiperoutine
Note1
Click on the name of the function
you wish to learn about...
"Command index"
"numpages"
num = NUMPAGES ()
eturn the number of pages in
the current hyperbook.
Button1
say numpages() 'pages'
"numpages"
PLNCNTSH
"hyperbookname"
name = HYPERBOOKNAME ()
eturn the name (i.e. the full path
name) of the current hyperbook.
Button1
say hyperbookname()
"hyperbookname"
"loadhyperbook"
bool (0 or 1) = LOADHYPERBOOK (filename)
oad the specified hyperbook.
"Load demo"
/* Attempt to load a hyperbook. This won't
   succeed until after a run of the test
   script for 
savehyperbook
 (see next page).
thispage = currentpage()
call beginprompt('Loading...')
if loadhyperbook('ram:rexxtest.hb') then do
   say 'Load succeeded.'
   call gotopage(thispage)
   end
   say 'Load failed.'
"loadhyperbook"
"savehyperbook"
bool (0 or 1) = SAVEHYPERBOOK (filename)
ave the current hyperbook under the given name.
"Save demo"
/* Save hyperbook as 'ram:rexxtest.hb' */
call beginprompt('Saving...')
if savehyperbook('ram:rexxtest.hb') then
   say 'Save succeeded.'
   say 'Save failed.'
"savehyperbook"
2INTB_COP
"hyperbooktofront"
HYPERBOOKTOFRONT ()
ring the HyperBook screen to the front.
Button1
call hyperbooktoback()
call pause(10)
call hyperbooktofront()
"hyperbooktofront"
"hyperbooktoback"
HYPERBOOKTOBACK ()
ush the HyperBook screen to the back.
Button1
call hyperbooktoback()
call pause(10)
call hyperbooktofront()
"hyperbooktoback"
"quithyperbook"
QUITHYPERBOOK ()
xit the HyperBook program.
Button1
/* A chance to quit... */
f getresponse('Really quit?') then
   call quithyperbook()
"quithyperbook"
"nextpage"
NEXTPAGE ()
quivalent to the right arrow
gadget on the main control panel.
Button1
call nextpage()
"nextpage"
"prevpage"
PREVPAGE ()
alent to the left arrow
gadget on the main control panel.
Button1
call prevpage()
"prevpage"
P_PREFIX)
"gotopage"
old = GOTOPAGE (new)
Go to the page whose objnum is 
; return the
objnum of the departed page.
Button1
/* Go to a random page, then return here */
pgnum   = rand(1, numpages())
oldpage = gotopage(objectnumber('', pgnum))
pgname  = getname(':')
call gotopage(oldpage)
say 'Page visited:' pgname '(' || pgnum || ')'
"gotopage"
uNU32
"callpage"
old = CALLPAGE (new)
o to the given new page, and return the
objnum of the departed page. A subsequent
RETURN will go back to the departed page.
Button1
call callpage('1:')
call return()
"callpage"
"return"
newpage = RETURN ()
ake current the last page called (from Table of Contents,
CALLPAGE, etc.), and return the objnum of that page.
Button1
call callpage(objectnumber('', rand(1,numpages()) ))
call return()
"return"
CINIT
"bigpanel"
BIGPANEL ()
ut the main control panel into
its `big' state.
Button1
call bigpanel()
"bigpanel"
"tinypanel"
TINYPANEL ()
ut the main control panel into
its `tiny' state.
Button1
call tinypanel()
"tinypanel"
LAYERSUPER
"controlpanel"
CONTROLPANEL (bool)
lose (arg = 0) or open (arg = 1) the
main control panel.
Button1
call bigpanel()
call controlpanel(0)
call inform('The panel is gone')
call controlpanel(1)
"controlpanel"
0000000)
"delete"
DELETE (arg)
elete a page, object or item, or
empty the bin.
Button1
I call 
DeleteStuff
Note2
The test button above calls the macro 
DeleteStuff
, which destroys everything
on this page, the contents of the bin, and the page itself. (Nothing is
permanently lost - the macro first clones this page.) To see the macro,
select the menu item 
ARexx/Edit macro
, and pick 
DeleteStuff
 from the list.
Group1
Button1
List1
items
deleted
DeleteStuff
macro.
"delete"
"relocate"
new = RELOCATE (arg, newparent)
ove the given object to the bin, a page or a group; or the given item
to a new list. Return the new objnum of the object or item moved.
Note2
The button calls the 
RelocateObject
 macro, which alternately relocates
it to the page and to the group with the black bar. List items clicked
on are relocated to the other list using the 
RelocateItem
 macro.
Button1
Button2
"reloc list 1"
alpha
gamma
delta
epsilon
"reloc list 2"
ALPHA
GAMMA
DELTA
EPSILON
"reloc group"
Drawing1
"reloc button"
group
Drawing2
"reloc button"
I call 
RelocateObject
"relocate"
"getbackground"
color = GETBACKGROUND (arg)
eturn the background color number of a page or object
(-1 is returned for transparent object backgrounds).
Button1
say 'Page background:' getbackground(':')
Button2
say 'Button background:' getbackground(initiator())
"getbackground"
"setbackground"
oldcolor = SETBACKGROUND (arg, newcolor)
et the background color of a page or object, and return the
old color. The object transparent `color' is -1.
Button1
call setbackground(':', 8 - getbackground(':'))
Button2
b=initiator(); call setbackground(b, 8 - getbackground(b))
"setbackground"
"getwidth"
width = GETWIDTH (arg)
eturn the width in pixels of the given page or object.
Button1
say 'Page width =' getwidth(':')
Button2
say 'My width =' getwidth(initiator())
"getwidth"
"getheight"
width = GETHEIGHT (arg)
eturn the height in scan-lines of the given page or object.
Button1
say 'Page height =' getheight(':')
Button2
say 'My height =' getheight(initiator())
"getheight"
	"getname"
name = GETNAME (arg)
eturn the name of a page or object.
Button1
say 'Page name:' getname(':')
Button2
say 'My name:' getname(initiator())
	"getname"
	"setname"
oldname = SETNAME (arg, newname)
et the name of the given page or
object, and return the previous
name.
	"Button1"
I call 
ChangeButtonName
Note2
The buttons call the 
ChangeButtonName
 macro, which toggles the name of
the first button on the current page between 
Button1
 and 
First button
and reports the old name; and the similar 
ChangePageName
 macro.
Button2
I call 
ChangePageName
	"setname"
"createpage"
page = CREATEPAGE (frompage, number)
reate a new page with the given page number using the page specified
by the 
frompage
 objnum as a template. The new page is a clone
frompage
 but does not have any objects on it. Giving zero 
the page number causes the new page to be appended to the hyperbook.
Return the objnum of the new page.
Button1
/* Create and go to new page;
clone the RETURN gadget onto it
ret = 'ReturnFromCreate'()
call callpage(createpage(':',0))
call clone(ret, ':')
"ReturnFromCreate"
/* Return from cloned page */
if numelements(':')==1 then do
pg = currentpage()
call return()
   call delete(pg)
   end
"createpage"
"clonepage"
page = CLONEPAGE (frompage, number)
reate a new page with the given page number using the page specified
by the 
frompage
 objnum as a template. The new page is a clone
frompage
, including
any objects on it.
Giving zero as the page
number causes the new
page to be appended to
the hyperbook. Return
the objnum of the new
page.
Button1
/* Clone this page; visit and rename clone */
call callpage(clonepage(':',0))
call setname(':', 'Copy of' getname(':'))
Button2
/* Delete page if it's the clone */
if left(getname(':'), 7) == 'Copy of' then do
pg = currentpage()
call return()
   call delete(pg)
   end
"clonepage"
"mastertopage"
page = MASTERTOPAGE(name, pos)
 new page is created at position 
 from the given
master page. The objnum of the new page is returned.
Button1
call callpage(mastertopage('Test Master', 0))
"mastertopage"
"pagetomaster"
PAGETOMASTER (page, name)
Clone t
he specified page, including any objects on it, and add it to the
master page list under the given name.
Button1
/* Turn this page into a master page, create a page from it,
   then delete both the created page and the master page.
call pagetomaster(':','Temporary master')
pg = mastertopage('Temporary master', 0)
call callpage(pg)
call inform("This page was made from 'Temporary Master'")
call return()
call delete(pg)
call deletemaster('Temporary master')
"pagetomaster"
"ismasterpage"
bool = ISMASTERPAGE (name)
eturn TRUE (1) if the given name is that of an existing master page.
Button1
m = ismasterpage('Test Master')
n = ismasterpage('Rumpelstiltskin')
not.0 = 'not a'
not.1 = 'a'
say "`Test Master' is" not.m "master page."
say "`Rumpelstiltskin' is" not.n "master page."
"ismasterpage"
"deletemaster"
DELETEMASTER (name)
elete the master page of the given name.
Button1
/* Step 1 */
call pagetomaster('1:','Porthos')
call pagetomaster('2:','Athos')
call pagetomaster('3:','Aramis')
call inform('Look at the master page list then run step 2')
Button2
/* Step 2 */
call deletemaster('Porthos')
call deletemaster('Athos')
call deletemaster('Aramis')
call inform('Three master pages have been deleted')
"deletemaster"
"loadpage"
page = LOADPAGE (file, num)
Load t
he specified file as page 
, and return the objnum of the
newly-loaded page. A page number of 0 loads to the last page.
Button1
call callpage(loadpage('hdat:loadpage.pg',0))
"loadpage"
"mergepage"
MERGEPAGE (parg, file)
erge the objects in the specified page file
onto the page whose objnum is 
Button1
call mergepage(':','hdat:mergepage.pg')
"mergepage"
"savepage"
SAVEPAGE (parg, file)
ave the specified page to the named file.
Button1
/* Save the current page, then load it in again to the
same place. The first and last lines are hoop-jumping
to avoid getting another copy of the ExecuteText macro.
call setactionnone(initiator())
call savepage(':','ram:foo.pg')
n=sequencenumber(':')
call delete(':')
call gotopage(loadpage('ram:foo.pg',n))
call setactionmacro('Button1'(), 'ExecuteText')
"savepage"
"getpagelace"
bool (1 or 0) = GETPAGELACE (page)
Returns 1 if the given page is in interlace mode, otherwise 0
Button1
if getpagelace(':') then n='on'; else n='off'; say 'Interlace is' n
"getpagelace"
"setpagelace"
bool (1 or 0) = SETPAGELACE (page, bool)
et the current page to interlace on (bool
argument 1) or off (bool argument 0).
Return the previous interlace state.
Button1
call setpagelace(':',1)
Button2
call setpagelace(':',0)
"setpagelace"
"getpagecolors"
count = GETPAGECOLORS (page)
eturn the number of colors in the palette of the given page.
Button1
say 'Color count =' getpagecolors(':')
"getpagecolors"
"setpagecolors"
oldcount = SETPAGECOLORS (arg, count)
et the number of colors (normalized to 4, 8 or 16) for
the current page's palette, and return the old count.
Button1
/* Alternate between 8 and 16 colors */
call setpagecolors(':', 24 - getpagecolors(':'))
Group1
Note1
Drawing1
Drawing2
Drawing3
Drawing4
Drawing5
Drawing6
Drawing7
Drawing8
Drawing9
	Drawing10
	Drawing11
	Drawing12
	Drawing13
	Drawing14
	Drawing15
	Drawing16
"setpagecolors"
"getpagergb"
rgb = GETPAGERGB (page, reg)
eturn the packed rgb value of color register 
 on the given
Button1
say 'Color 3 RGB = $' || right(d2x(getpagergb(':',3)),4,'0')
"getpagergb"
"setpagergb"
oldrgb = SETPAGERGB (page, reg, rgb)
et the color register 
 on the given page to the new
rgb value, and return the old value of that register.
Button1
call setpagergb(':',0,c2d('0fda'x))
Button2
call setpagergb(':',0,c2d('0fff'x))
"setpagergb"
"wiperoutine"
old = WIPEROUTINE (page, new)
et/set the wipe effect used by the given
page. Values for 
 in the range 0 to 17 will
change the page effect as per the list at
right; other values (e.g. -1) do not select a
new effect.
"fxlist"
 0 - NONE -
 1 Instant
 2 Left to right
 3 Right to left
 4 Top to bottom
 5 Bottom to top
 6 Curtain
 7 Expand from center
 8 Random blocks
 9 Dissolve
10 Double dissolve
	11 Blinds
12 Tiles - Expanding
13 Tiles - Shrinking
14 Tiles - Growing
15 Tiles - Diagonal
16 Tiles - Clock
17 Roll
Button1
/* Select and demonstrate page effect */
list = 'fxlist'()
it   = selectitem(list,'Select an effect')
call wiperoutine(':',sequencenumber(it)-1)
call nextpage()
call prevpage()
"wiperoutine"
	"pagedim"
old = PAGEDIM (page, new)
et/set the screen dimming effect that precedes the wipe
effect for the given page, and return the previous setting.
 value of 0 turns dimming off; 1 turns it on. Other
values (e.g. -1) do not change the current setting.
Button1
old = pagedim(':',-1)
call pagedim(':',1 - old)
call nextpage()
call prevpage()
call pagedim(':',old)
	"pagedim"
"setpagenumber"
new = SETPAGENUMBER (page, num)
esequence the page whose position is 
, and return its new objnum.
Button1
/* Execute this button twice in order not to disturb the page order */
say 'This page is now' setpagenumber(':', 50 - sequencenumber(':'))
"setpagenumber"
"refreshpage"
REFRESHPAGE ()
Redraw the current page.
Button1
call refreshpage()
Group1
Drawing1
Drawing2
Drawing3
Drawing4
Drawing5
Drawing6
Drawing7
Drawing8
Drawing9
	Drawing10
	Drawing11
	Drawing12
	Drawing13
	Drawing14
	Drawing15
	Drawing16
	Drawing17
	Drawing18
	Drawing19
	Drawing20
"refreshpage"
"createnote"
note = CREATENOTE ()
reate an empty note of size 61x23 and position (0,0) in the bin, using
the current default note attributes, and return its objnum.
Button1
n = createnote()
call scaletosize(n, 135, 50)
call setposition(n, 412, 115)
call inserttext(n,'I am a newly-created note.',0)
call setbackground(n,5)
call relocate(n, ':')
"createnote"
"createbutton"
button = CREATEBUTTON ()
reate an empty button of size 33x17 and position (0,0) in the bin,
using the current default button attributes, and return its objnum.
Button1
b = createbutton()
call scaletosize(b, 145, 21)
call setposition(b, 247, 159)
call inserttext(b, 'I delete myself', 0)
call setactionrexx(b, 'call delete(initiator())')
call setbackground(b, 2)
b = relocate(b, ':')
"createbutton"
"createlist"
list = CREATELIST ()
reate an empty list of size 65x43 and position (0,0) in the bin,
using the current default list attributes, and return its objnum.
Button1
list = createlist()
call scaletosize(list,123,90)
call setposition(list,509,61)
fox = 'The quick brown fox jumps over the lazy dog'
do i = 1 to 9
   call appenditem(list, subword(fox,i,1), 1)
call relocate(list, ':')
"createlist"
"creategroup"
group = CREATEGROUP ()
reate an empty group object in the bin, and return its objnum.
"creategroup macro"
/* Create a group to contain both the note and the button
on this page, or explode such a group if it exists. */
call interactive(0)
if gettype(':1') = 'Group' then
   call explode(':1')
else do
   g = creategroup()
   call relocate(searchname(':',creategroup),g)
   call relocate(initiator(),g)
   call relocate(g, ':')
   end
call listcurrentpage()
"creategroup"
"clone"
new = CLONE (arg, newparent)
lone the given object to the bin, a page or a group; or the given item
to a new list. 
 is unchanged. Return the clone's objnum.
Button1
"clone button"
I call 
CloneObject
Note2
The button calls the 
CloneObject
 macro, which clones it to the group with
the black bar. List items clicked on are cloned to the other list using
CloneItem
 macro. Delete the clones by hand to restore the page.
Button3
"clone list 1"
alpha
gamma
delta
epsilon
"clone list 2"
ALPHA
GAMMA
DELTA
EPSILON
"clone group"
Drawing1
Group1
"reloc button"
group
Drawing2
"clone"
	"getleft"
left = GETLEFT (obj)
eturn the left edge position of the object, measured in
pixels from the left edge of its page.
Button1
say 'My left edge is' getleft(initiator())
	"getleft"
"gettop"
top = GETTOP (obj)
eturn the top edge position of the object, measured in
scan-lines from the top edge of its page.
Button1
say 'My top edge is' gettop(initiator())
"gettop"
"setposition"
SETPOSITION (obj, x, y)
et the left and top co-ordinates of the given object.
Button1
/* Randomly reposition this button:  
Move Me
i    = initiator()
b    = 'MoveMe'()
left = rand(0, getwidth(i)  - getwidth(b)  - 1)
top  = rand(0, getheight(i) - getheight(b) - 1)
call setposition(b, left + getleft(i), top + gettop(i))
"MoveMe"
$call setposition(initiator(),347,55)
Move Me
"setposition"
"getborder"
border = GETBORDER (obj)
eturn the border color of the object, or -1 if the
object's border is transparent.
Button1
say 'My border color is' getborder(initiator())
"getborder"
"setborder"
oldcolor = SETBORDER (obj, color)
et the border of the object to the given color, and
return the previous color. The transparent `color' is -1.
Group1
Button1
Button2
Button3
b = objectnumber(parent(initiator()),2)
call setborder(b, rand(-1,7))
"setborder"
"getshadow"
shadow = GETSHADOW (obj)
eturn the shadow color of the object, or -1 if the
object's shadow is transparent.
Button1
say 'My shadow color is' getshadow(initiator())
"getshadow"
"setshadow"
oldcolor = SETSHADOW (obj, color)
et the shadow of the object to the given color, and return the
previous color. The transparent `color' is -1.
Button1
call setshadow(initiator(),rand(-1,7))
"setshadow"
"shadowstyle"
old = SHADOWSTYLE (obj, style)
et/set the style of shadow used by 
. The available styles are
drop-shadow (
style
 = 1) and embossed (2). Any other value (e.g. 0)
doesn't change the current shadow style setting.
Button1
call interactive(0)
ss = shadowstyle(initiator(), 0)
if ss = 2 then
   b = 6  
/* orange */
   b = 1  
/* black  */
call shadowstyle(initiator(), 3-ss)
call setborder(initiator(), b)
"shadowstyle"
"getvisibility"
bool (1 or 0) = GETVISIBILITY (obj)
eturn 1 if the `natural visibility state' of
the object is visible, or 0 if it is invisible.
Button1
n = 'VisiButton'()
if getvisibility(n) then
   say 'Visible'
   say 'Invisible'
Group1
9b='VisiButton'(); call setvisibility(b,~getvisibility(b))
"VB_Frame"
	"ClickMe"
Click Me
"VisiButton"
VisiButton
"getvisibility"
"setvisibility"
bool (1 or 0) = SETVISIBILITY (obj, state)
et the `natural visibility state' of the
object to visible (1), or invisible (0). Return
the previous state.
Button1
b = 'Cheshire face'()
call setvisibility(b, ~getvisibility(b))
Group1
Button1
Button2
Note1
"Cheshire face"
Note2
"setvisibility"
"scale"
SCALE (obj, percent)
cale the object's width and
height to the given percentage
of its current dimensions.
"GoodTime"
For a good
time call
favorite
restaurant
and make a
reservation.
Enjoy a
fine,
healthy meal
with a
friend or
family
member.
Button1
n = 'GoodTime'()
if getwidth(n) < 150 then
   call scale(n, 200)
   call scale(n, 50)
"scale"
"scaletosize"
SCALETOSIZE (obj, width, height)
Scale the object to the given width and height.
Button1
n = 'Planets'()
call interactive(0)
if getwidth(n) < 200 then do
   call setposition(n,20,170)
   call scaletosize(n,520,18)
   end
else do
   call setposition(n,438,68)
   call scaletosize(n,90,100)
   end
	"Planets"
Mercury Venus Earth Mars Jupiter Saturn Uranus Neptune Pluto
"scaletosize"
"objecttoback"
objnum = OBJECTTOBACK (obj)
ring the given object to the
back of its group/page and
return its new objnum.
Button1
btn = objecttoback(initiator())
call inform('Continue...')
call objecttofront(btn)
"objecttoback"
"objecttofront"
objnum = OBJECTTOFRONT (obj)
ring the given object to the
front of its group/page and
return its new objnum.
Button1
n = searchname(':',objecttofront)
n = objecttofront(n)
call inform('Continue...')
call objecttoback(n)
"objecttofront"
"getgroupdepth"
depth = GETGROUPDEPTH (obj)
eturn the grouping depth of the given
object, starting with 0 if the object is
not in a group.
Button1
/* List the grouping depth of
   objects on this page
do i=1 to totalelements(':')
o = objectnumber(':',i)
d = getgroupdepth(o)
say 'Object' o || ', depth =' d
Group1
Note1
Drawing1
Group1
Drawing1
Group1
Drawing1
Group1
Drawing1
Drawing2
"getgroupdepth"
	"explode"
firstobj = EXPLODE (group)
xplode the given group, and insert its constituent
objects in the group's place in its parent list.
Return the objnum of the first of these objects
(or the empty string if the group had no objects).
Button1
/* Explode the group of rectangles at right.
   Re-group them afterwards to restore the page.
call explode('Rectangles'())
Group1
Note1
	"Regroup"
	"Regroup"
	"Regroup"
"Regroup_macro"
parent('Dra
wing1'())
currentpage
() then
   exit
interactive
g=creategro
relocate('D
rawing4'(),
relocate('D
rawing3'(),
relocate('D
rawing2'(),
relocate('D
rawing1'(),
setbackgrou
nd(g,7)
setborder(g
setshadow(g
shadowstyle
(g,2)
setposition
(g,497,53)
setname(g,'
Rectangles'
relocate(g,
Button1
.interpret readnotetext('Regroup_macro'(),0,-1)
Click here
to regroup
"Rectangles"
Drawing1
Drawing2
Drawing3
Drawing4
	"explode"
"getaction"
action = GETACTION (arg)
eturn the action type associated with the given object or
item, one of: 
noaction
gopage
showpic
showhide
displaytext
doscommand
rexxcommand
rexxmacro
Button1
I call FindAction
Note2
The main button calls the 
FindAction
 macro, which
invites you to click on an object then tells you its
action. The small buttons invoke various actions.
Group1
Note1
Button1
Button2
Button3
	hdat:odie
Button4
Button5
	hdat:text
Button6
say "Greetings from Hy-perBook"
Button7
0call inform('Greetings from object' initiator())
Button8
"getaction"
"Informative note"
The main button calls the 
FindActionText
 macro, which
invites you to click on an object then tells you its
action text. The small buttons invoke various actions.
"getactiontext"
action = GETACTIONTEXT (arg)
eturn the text associated with the given object or item's action.
Group1
Note1
Button1
Button2
Button3
	hdat:odie
Button4
Button5
	hdat:text
Button6
say "Greetings from Hy-perBook"
Button7
0call inform('Greetings from object' initiator())
Button8
Button1
I call FindActionText
"getactiontext"
"setactionnone"
oldact = SETACTIONNONE (arg)
et the action of the specified object or item to 
noaction
. Return the
type of the former action.
Button1
call setactionnone('Act3'())
Button2
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button
clears Act3's action; the second restores it (to the HML
command string returned by the 
getBGtext
 macro).
"setactionnone"
"setactionpage"
oldact = SETACTIONPAGE (arg, parg)
et the action of the specified object or item to 
gopage
. The page's
objnum is 
. Return the type of the former action.
Button1
call setactionpage('Act3'(), ':')
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button changes Act3's
action to 
gopage
 (linking it to 
 page); the second restores it (to
the HML command string returned by the 
getBGtext
 macro).
"setactionpage"
"setactionpic"
oldact = SETACTIONPIC (arg, name)
et the action of the specified object or item to 
showpic
. The picture
is the ILBM file 
. Return the type of the former action.
Button1
call setactionpic('Act3'(), 'hdat:odie')
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button
changes Act3's action to 
showpic
; the second restores it (to
the HML command string returned by the 
getBGtext
 macro).
"setactionpic"
"setactionshow"
oldact = SETACTIONSHOW (arg, oarg)
et the action of the specified object or item to 
showhide
. The objnum
of the target object is 
. Return the type of the former action.
Button1
call setactionshow('Act3'(), 'hidden object'())
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button
changes Act3's action to 
showhide
; the second restores it
(to the HML command string returned by the 
getBGtext
 macro).
"hidden object"
Drawing1
Note1
Hidden object
"setactionshow"
"setactionread"
oldact = SETACTIONREAD (arg, name)
et the action of the specified object or item to 
displaytext
. The text
is in the file 
. Return the type of the former action.
Button1
call setactionread('Act3'(), 'hdat:text')
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button
changes Act3's action to 
displaytext
; the second restores it
(to the HML command string returned by the 
getBGtext
 macro).
"hidden object"
Drawing1
Note1
Hidden object
"setactionread"
"setactiondos"
oldact = SETACTIONDOS (arg, cmd)
et the action of the specified object or item to 
doscommand
. The
command is the string 
. Return the type of the former action.
Button1
call setactiondos('Act3'(), 'dir >hdat:files')
"action restore"
call setactionrexx('Act3'(), 'call showtext("hdat:files")')
"Act3"
call showtext("hdat:files")
call showtext("hdat:files")
Note2
The name of the third button is `Act3'. The first button changes
Act3's action to 
doscommand
 (creating a current-directory listing).
The second restores it (to displaying the generated listing).
"hidden object"
Drawing1
Note1
Hidden object
"setactiondos"
"setactionrexx"
oldact = SETACTIONREXX (arg, dos)
et the action of the specified object or item to 
rexxcommand
. The
command is the string 
. Return the type of the former action.
Button1
call setactionrexx('Act3'(), 'call tinypanel()')
"action restore"
call setactionrexx('Act3'(), 'call bigpanel()')
"Act3"
call bigpanel()
call bigpanel()
Note2
The name of the third button is `Act3'. The first
button changes Act3's action to 
rexxcommand
tinypanel()
). The second restores it (
call bigpanel()
"hidden object"
Drawing1
Note1
Hidden object
"setactionrexx"
"setactionmacro"
oldact = SETACTIONMACRO (arg, marg)
et the action of the specified object or item to 
rexxmacro
. The named
macro (
) is used. Return the type of the former action.
Button1
call setactionmacro('Act3'(), 'FindActionText')
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
Note2
The name of the third button is `Act3'. The first button
changes Act3's action to 
rexxmacro
; the second restores it
(to the HML command string returned by the 
getBGtext
 macro).
"hidden object"
Drawing1
Note1
Hidden object
"setactionmacro"
"setactionlink"
oldact = SETACTIONLINK (arg, linktype)
et the action of the specified object or item to one of the special
variants of the 
gopage
 action: 
nextpage
prevpage
firstpage
lastpage
return
selectpage
. Return the type of the former action.
Note2
The name of the third button is `Act3'. The first button changes
Act3's action to 
gopage
 (the 
nextpage
 variant); the second restores
it (to the HML command string returned by the 
getBGtext
 macro).
"hidden object"
Drawing1
Note1
Hidden object
Button1
call setactionlink('Act3'(), 'nextpage')
"action restore"
call setactionrexx('Act3'(), getBGtext())
"Act3"
8b=initiator(); call setbackground(b, 9-getbackground(b))
b=initiator(); call setbackground(b, 9-getbackground(b))
"setactionlink"
"activate"
ACTIVATE (object)
xecute the action for the given object or item as though it had
been clicked on.
"LeftButton"
call activate('RightButton'())
"RightButton"
say getname(initiator())
I say the name of the
initiating object
Note2
The left button above activates the right button,
whose 
rexxcommand
 action is: 
say getname(initiator())
"activate"
"readnotetext"
str = READNOTETEXT (arg, pos, amt)
eturn a string consisting of 
 characters beginning at 
 in the
given note or button. An 
 of -1 means `to the end of text'.
Button1
/* Synopsize promotional message below */
ob = 'Promo'()
say readnotetext(ob,79,4) readnotetext(ob,47,7)
Group1
"Promo"
Happy computing!
rom the good folks at Apple, the
machine to complement 
 skill!
Button2
Button3
"readnotetext"
"inserttext"
INSERTTEXT (arg, text, pos)
nsert 
 in the given note or
button. If 
 is -1, the text is appended.
Button1
n = 'Very tired'()
call inserttext(n, 'very, ', 5)
Group1
Button1
Button2
"Very tired"
4call replacetext(initiator(),'I am very tired',0,-1)
I am very tired
"inserttext"
"replacetext"
oldtext = REPLACETEXT (arg, text, pos, amt)
he new text replaces 
 characters, beginning at 
 in the
given note or button. An 
 of -1 means `to the end of text'.
Button1
note  = 'proven'()
first = readnotetext(note, 32, 3)
f first = 'egg' then
   call replacetext(note,'chicken',32,3)
   call replacetext(note,'egg',32,7)
Group1
"proven"
It has now been proven that the egg came first.
Button1
Button2
"replacetext"
"cleartext"
CLEARTEXT (arg)
emove all the text from the given note or button.
Button1
note = 'cleartext note'()
if length(readnotetext(note,0,-1)) > 1 then
   call cleartext(note)
   call inserttext(note, 'Easy come, easy go.', 0)
Group1
"cleartext note"
Easy come, easy go.
Button1
Button2
"cleartext"
"deletetext"
oldtext = DELETETEXT (note, pos, amt)
elete 
 characters beginning at 
 in the
given note or button, and return the deleted
text. An 
 of -1 means `to the end of text'.
Button1
call interactive(0)
m = 'Marvin'()
n = 'Edgar'()
call inserttext(m, deletetext(n, 34, 4), 38)
call inserttext(n, deletetext(m, 42, 4), 34)
Group1
Note1
"Marvin"
Marvin was
famous for his
sensitive palate.
"Edgar"
But Edgar
always beat him
to the punch.
"deletetext"
"getitemcolor"
color = GETITEMCOLOR (item)
Return the color of the given item.
Note2
In the test list above, each item's action is the HML command:
say 'My color is' getitemcolor(initiator())
Group1
Button1
"getitemcolor list"
+say 'My color is' getitemcolor(initiator())
Click
+say 'My color is' getitemcolor(initiator())
+say 'My color is' getitemcolor(initiator())
+say 'My color is' getitemcolor(initiator())
these
+say 'My color is' getitemcolor(initiator())
items.
"getitemcolor"
"setitemcolor"
old = SETITEMCOLOR (item, color)
et the color of the given item, and return
its previous color.
Note2
In the test list above, each item's action is the HML command:
call setitemcolor(initiator(), rand(0,7))
Group1
Button1
"setitemcolor list"
(call setitemcolor(initiator(),rand(0,7))
Click
(call setitemcolor(initiator(),rand(0,7))
(call setitemcolor(initiator(),rand(0,7))
(call setitemcolor(initiator(),rand(0,7))
these
(call setitemcolor(initiator(),rand(0,7))
items.
"setitemcolor"
"getitemtext"
text = GETITEMTEXT (item)
eturn the text string associated with
the given item.
Button1
l = 'getitemtext list'()
say 'Words of 8 letters or more' '0a'X
do i = 1 to numelements(l)
t = getitemtext(objectnumber(l,i))
if length(t) >= 8 then say '  ' t
   end
Group1
Note1
"getitemtext list"
hydrogen
helium
lithium
	beryllium
boron
carbon
nitrogen
oxygen
fluorine
sodium
	magnesium
"getitemtext"
"setitemtext"
oldtext = SETITEMTEXT (item, text)
et the item text to text, and return
the former text.
Note2
In the test list above, each item's action is the HML command:
=initiator(); t=getitemtext(i); if left(t,1)==' ' then
   setitemtext(i,substr(t,2)) rand(0,7))
Group1
Button1
"replaceitem list"
Wi=initiator(); t=getitemtext(i); if left(t,1)==' ' then call setitemtext(i,substr(t,2))
      Click
Wi=initiator(); t=getitemtext(i); if left(t,1)==' ' then call setitemtext(i,substr(t,2))
	      any
Wi=initiator(); t=getitemtext(i); if left(t,1)==' ' then call setitemtext(i,substr(t,2))
      of
Wi=initiator(); t=getitemtext(i); if left(t,1)==' ' then call setitemtext(i,substr(t,2))
      these
Wi=initiator(); t=getitemtext(i); if left(t,1)==' ' then call setitemtext(i,substr(t,2))
      items.
"setitemtext"
"insertitem"
item = INSERTITEM (next, text, color)
reate a new item with the given color and text,
inserted before item 
 in its list, and return
the objnum of the new item.
Button1
/* Insert names between 'John' and 'Schmidt' */
i = 'insertitem list'()
n  = numelements(li)
i  = objectnumber(li,rand(2,n))
tx = inputstring('Enter name','Jacob')
call insertitem(i,tx,1)
Group1
Button1
"insertitem list"
Schmidt
"insertitem"
"appenditem"
item = APPENDITEM (list, text, color)
Create a new item with the given color and text,
append it to the given list, and return its objnum.
Button1
li = 'appenditem list'()
call appenditem(li,'Item' numelements(li)+1,2)
Group1
Button1
"appenditem list"
"appenditem"
"moveitem"
item = MOVEITEM (olditem, pos)
Move t
he given item within its
list to position 
, and return
its new objnum.
Group1
Note1
"moveitem list"
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
hydrogen
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
helium
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
lithium
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
	beryllium
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
boron
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
carbon
=i=initiator();call moveitem(i,rand(1,numelements(parent(i))))
nitrogen
"moveitem"
"clearlist"
CLEARLIST (list)
mpty the given list of all items.
Button1
list = 'clearlist list'()
list = clone(list, ':')
call clearlist(list)
call inform('Animals list clone now empty...')
call delete(list)
Group1
Note1
"clearlist list"
monkey
narwhal
tiger
okapi
rhinoceros
zebra
penguin
gibbon
walrus
dugong
Note2
The macro in the button clones the list of animals, then clears
the list. Upon confirming a requester, the clone is deleted.
"clearlist"
"sortlist"
SORTLIST (list1 [,list2, ..., listn])
Sort t
he items in the given list in ascending lexical order. If more than
one list is given, the first is sorted, and the others are re-ordered in
the same way as 
list1
. All the lists must
have the same number of items.
Button1
/* sort elements alphabetically */
call sortlist('elements'(),'atomnums'())
Button2
/* sort elements by atomic number */
call sortlist('atomnums'(),'elements'())
"Elements"
hydrogen  (AN1)
helium    (AN2)
lithium   (AN3)
beryllium (AN4)
boron     (AN5)
carbon    (AN6)
nitrogen  (AN7)
oxygen    (AN8)
fluorine  (AN9)
neon      (AN10)
sodium    (AN11)
"AtomNums"
"sortlist"
"refreshlist"
REFRESHLIST (list)
edraw the given list. Use this to force a
refresh while the INTERACTIVE flag is turned off
(which normally suppresses list rendering).
Button1
list = 'refreshee'()
all interactive(0)
o i=1 to numelements(list)
   call setitemcolor(objectnumber(list,i),2)
   end
call refreshlist(list)
o i=1 to numelements(list)
   call setitemcolor(objectnumber(list,i),1)
   end
Group1
Note1
"refreshee"
hydrogen
helium
lithium
	beryllium
boron
carbon
nitrogen
oxygen
fluorine
sodium
	magnesium
"refreshlist"
"listscroll"
LISTSCROLL (item)
croll the given item's list so that the
item is at the top, or as near as possible
to the top, of the list's display area.
Button1
li = 'listscroll list'()
n  = numelements(li) - 4
it = objectnumber(li, rand(1,n))
call listscroll(it)
Group1
Note1
"listscroll list"
 1 hydrogen
	 2 helium
 3 lithium
 4 beryllium
 5 boron
	 6 carbon
 7 nitrogen
	 8 oxygen
 9 fluorine
10 neon
	11 sodium
12 magnesium
"listscroll"
"listheight"
count = LISTHEIGHT (list)
eturn the number of items the given list can
display at its current size. The list does not
necessarily contain this many items.
Button1
bl = 'black list'()
rl = 'blue list'()
bc = listheight(bl)
rc = listheight(rl)
say 'The black list can show' bc 'items.'
say 'The blue list can show' rc 'items.'
Group1
Note1
"Black list"
three
"Blue list"
three
seven
eight
"listheight"
"searchstart"
SEARCHSTART (start)
et the default starting point for SEARCHNAME, SEARCHPAGENAME and
SEARCHTEXT. If 
start
 is an objnum, set the starting point to the
corresponding page and object (if the objnum is that of a page or the
bin, the object is taken to be the first in the relevant object list).
An empty 
start
 string is equivalent to specifying '1:' - the first page.
Button1
call searchstart(':')
say 'From this page, found' getname(searchtext('','search'))
Button2
call searchstart('')
say 'From start, found' getname(searchtext('','search'))
"searchstart"
"searchname"
obj = SEARCHNAME (start, substr)
rom the given starting point in the hyperbook, search for an
object whose name contains 
substr
, and return its objnum (the
empty string if not found). If the 
start
 argument is empty,
the search begins where the most recent search left off, or
at the point set by SEARCHSTART. The search is case insensitive.
Button1
ob = searchname(':','butt')
f length(ob) > 0 then
   say 'Found' getname(ob)
"searchname"
"searchpagename"
obj = SEARCHPAGENAME (start, substr)
rom the given starting point in the hyperbook, search for a page
whose name contains 
substr
, and return its objnum (the empty string
if not found). If the 
start
 argument is the empty string, the search
begins where the most recent search left off, or at the point set by
SEARCHSTART. The search is case insensitive.
Button1
p=searchpagename('1:','search')
f length(p) > 0 then
   say 'Found' getname(p)
"searchpagename"
"searchtext"
obj = SEARCHTEXT (start, substr)
rom the given starting point in the hyperbook, search for an object
or list whose text contains 
substr
, and return its objnum (the empty
string if not found). If 
start
 is the empty string, the search begins
where the most recent search left off, or as set by SEARCHSTART. The
search is case insensitive.
"Left searchtext button"
/* Find the first note or
list whose text contains
the word `begin'. */
ob=searchtext('1:','begin')
f length(ob)>0 then
say 'Found' getname(ob)
"Right searchtext button"
/* Search for another */
ob=searchtext('','begin')
f length(ob)>0 then 
say 'Found' getname(ob)
say 'Not found'
"searchtext"
"searchitems"
item = SEARCHITEMS (arg, text)
earch a list (from the beginning, if 
 is a
list; or from the given item) for 
, and
return either the objnum of the item containing
the text or, if the search failed, the empty
string. The search is case insensitive.
Button1
list = 'searchitems list'()
item = searchitems(list, 'turkey')
item = searchitems(item, 'chicken')
say 'Found chicken in' getitemtext(item)
Group1
Note1
"searchitems list"
chicken soup
turkey sandwich
chicken pie
duck 
 l'orange
chicken feet
"searchitems"
"searchnote"
pos = SEARCHNOTE (arg, pattern, start)
earch the given note or button, 
, starting at
position 
start
, for the string 
pattern
, and return
the position at which it is found, or -1 if the
search fails. The search is case insensitive.
Button1
note = 'Quick Brown Fox'()
c  = substr(xrange('a','z'),rand(1,26),1)
p  = searchnote(note, c, 0)
say "Found letter `" || c || "' at position" p
Group1
"Quick Brown Fox"
The quick brown
fox jumps over
the lazy dog.
Button1
Button2
"searchnote"
"getresponse"
bool (1 or 0) = GETRESPONSE (prompt)
ut up the Okay/Cancel requester with the
given prompt string. Return 1 if the user
clicks Okay (the checkmark), 0 for Cancel
(the X).
Button1
if getresponse('Okay or cancel?') then
   say 'Okay'
   say 'Cancel'
"getresponse"
"inputstring"
str = INPUTSTRING (prompt, default)
rompt the user to enter a string (modifying the given text, if 
default
is non-empty) and return it. Note: the empty string is returned if the
user cancels the requester.
Button1
say 'You entered "' || inputstring('Enter a string', 'Default') || '"'
"inputstring"
"inputform"
text = INPUTFORM (prompt, formtext)
btain multiple lines of input from the user. 
Formtext
 specifies the
label and the default string for each input line in this format:
   <label>:<text>[<LF><label>:<text> ...]
where LF is a linefeed (in ARexx, a linefeed is 
'0a'X
). The returned
text consists of the input strings separated by LFs.
Button1
cr = '0a'X
fm = 'Animal:' || cr || 'Origin:Africa' || cr || 'Class:mammal'
tx = inputform('Enter information for animal', fm)
if tx = '' then EXIT
parse var tx animal '0a'X origin '0a'X class
say 'The' animal 'is a' class 'from' origin || '.'
"inputform"
"inputobject"
obj = INPUTOBJECT (prompt)
Prompt the user
 to select an object from a list of
those on the current page. Return the objnum of
the selected object.
"inputobject demo"
ob = inputobject('Select an object')
say 'You selected' ob '(' || getname(ob) || ')'
"Framed boxes"
"Frame"
"Five boxes"
	"Red box"
"Four boxes"
"Orange box"
"Three boxes"
"White box"
"Two boxes"
"Yellow box"
"Black box"
"inputobject"
"inputpage"
page = INPUTPAGE (prompt)
Prompt t
he user to select a page from the page
list. Return the objnum of the selected page.
Button1
p = inputpage('Pick a page')
say 'Page chosen:' p '(' || getname(p) || ')'
"inputpage"
Note1
"selectitem"
item = SELECTITEM (list, prompt)
isplay the given prompt to the user, and wait for
a click on an item in the given list. Return the
objnum of the selected item.
Button1
li = 'selectitem list'()
it = selectitem(li, 'Click on a list item')
say 'You selected "' || getitemtext(it) || '"'
"selectitem list"
hydrogen
helium
lithium
	beryllium
boron
carbon
nitrogen
oxygen
fluorine
sodium
	magnesium
"selectitem"
"getclickrow"
row = GETCLICKROW (prompt)
Display the given prompt in a bar at the top the screen. When the user
clicks on the page, return the number of the scan-line clicked on.
Button1
say 'You clicked on line' getclickrow('Click somewhere on the page')
"getclickrow"
"getcolumn"
col = GETCOLUMN ()
eturn the column that was clicked on the
last time GETCLICKROW was called.
Button1
y = getclickrow('Click somewhere')
say 'Click x =' getcolumn() 'y =' y
"getcolumn"
"getobjectat"
obj = GETOBJECTAT (x, y)
eturn the objnum of the object at page
co-ordinates (x,y). A null objnum (the empty
string) is returned if there is no object at the
given co-ordinates.
Button1
y = getclickrow('Click on an object')
x = getcolumn()
say 'objnum is "' || getobjectat(x,y) || '"'
Group1
Note1
Group1
Drawing1
Group1
Drawing1
Group1
Drawing1
Group1
Drawing1
Drawing2
"getobjectat"
"beginprompt"
BEGINPROMPT (text)
pen the prompt window along the top of the
screen, containing the given text. If not closed with
ENDPROMPT, the window will close automatically when
the script finishes executing.
"beginprompt script"
call beginprompt('This is a prompt window')
call inform('Continue...')
"beginprompt"
"endprompt"
ENDPROMPT ()
lose the prompt window (opened with BEGINPROMPT).
"endprompt script"
call beginprompt('This is a prompt window')
call inform('Ready to close prompt window?')
call endprompt()
call inform('Prompt window now closed')
"endprompt"
"filerequest"
file = FILEREQUEST (prompt, default)
pen a file requester with the given prompt and default
AmigaDOS path name, and return the path name selected by
the user. Return the empty string if the user cancels.
Button1
name = filerequest('Select a file', 'c:echo')
say 'You selected "' || name || '"'
"filerequest"
"loadtext"
text = LOADTEXT (filename)
eturn a string whose value is the
entire contents of the given file.
Button1
say loadtext('s:startup-sequence')
"loadtext"
"savetext"
SAVETEXT (file, text)
reate a file whose contents is the given text.
Button1
text = readnotetext(initiator(),0,-1)
call savetext('ram:test_file', text)
say loadtext('ram:test_file')
address command 'delete ram:test_file'
"savetext"
"savemoretext"
SAVEMORETEXT (file, text)
ppend the given text to an existing file.
Button1
text = 'This file grows and grows.' || '0a'X
call savemoretext('ram:test_file', text)
say loadtext('ram:test_file')
"savemoretext"
"edittext"
newtext = EDITTEXT (name, text)
Make t
he text available for editing in the built-in text editor, displaying
the given name in the editor's title bar. Return the edited text.
Button1
note = 'edittext note'()
call inserttext(note,edittext('Edit Text',deletetext(note,0,-1)),0)
"edittext note"
(Your thoughts go here.)
"edittext"
"getprintwidth"
width = GETPRINTWIDTH ()
eturn the printer line width as set in Preferences,
calculated as: right margin - left margin + 1.
Button1
say 'Print-line width:' getprintwidth()
"getprintwidth"
"formattext"
newtext = FORMATTEXT (text, margin, width)
reate and return a new string in which the given string
has been word-wrapped to lines of 
width
 characters, with
margin
 extra spaces added to the beginning of each line
(these are not counted as part of 
width
Button1
note = searchname(':', 'formattext')
say formattext(readnotetext(note,0,-1),10,43)
"formattext"
"printpage"
bool (1 or 0) = PRINTPAGE ()
rint the current page... this is just like
selecting 
Print Page
 on the 
Project
 menu. Return
1 if the print succeeded, otherwise 0.
Button1
/* Print this page... takes 30 seconds to
   come back if printer is not connected.
call printpage()
"printpage"
	"showpic"
bool = SHOWPIC (file)
isplay the given ILBM file. Return FALSE (0)
if the file does not exist.
Button1
if showpic('hdat:odie') = 0 then
   say "Can't find file"
	"showpic"
"showtext"
bool = SHOWTEXT (file)
isplay the given text file. Return FALSE (0)
if the file does not exist.
Button1
if showtext('hdat:text') = 0 then
   say "Can't find file"
"showtext"
"showtextrange"
bool (1 or 0) = SHOWTEXTRANGE (file, start, amt)
isplay a text range from the given file, beginning
start
 bytes into the file and continuing for 
bytes. (The equivalent line number values for 
start
 can be converted to byte values with the
`textrange' utility.)
Button1
if showtextrange('hdat:text',541,664) = 0 then
   say "Can't find file"
"showtextrange"
"numelements"
num = NUMELEMENTS (arg)
eturn the number of elements in a page, the bin, a
group or a list. A group is counted as one element,
regardless of how many objects it contains.
"Group of 4"
Note1
This group contains four elements.
Button1
'say 'Objects on page:' numelements(':')
numelements (page)
Button2
.say 'Group count:' numelements('Group of 4'())
numelements (group)
Button3
,say 'List count:' numelements('List of 5'())
numelements (list)
Group2
Note1
"List of 5"
	elements.
Note2
Button macros
Left button  :
 say 'Objects on page:' numelements(':')
Middle button
: say 'Group count:' numelements('Group of 4'())
Right button :
 say 'List count:' numelements('List of 5'())
"numelements"
"sequencenumber"
num = SEQUENCENUMBER (arg)
eturn the list position of a page, object or
item, counting from 1. For objects within a
group, the position returned is relative to
the group, not the containing page.
Button1
say 'Page' sequencenumber(':')
Button2
say 'Object' sequencenumber(initiator())
"sequencenumber"
"totalelements"
num = TOTALELEMENTS (arg)
eturn the number of elements contained in a page, the bin, a list
object or a group at all levels (i.e. including nested groups). This is
equivalent to NUMELEMENTS only for lists.
Note2
Button macros
Left button  :
 say 'Total objects on page:' totalelements(':')
Middle button
: say 'Group 1 count:' totalelements('Group of 5'())
Right button :
 say 'Group 2 count:' totalelements('Group of 6'())
"Group of 5"
Note1
(Group 1,
5 elements,
one of
which is
Group 2)
"Group of 6"
Note1
(Group 2, 6 elements)
Drawing1
Drawing2
Drawing3
Drawing4
Drawing5
Button1
/say 'Total objects on page:' totalelements(':')
totalelements
(page)
Button2
2say 'Group 1 count:' totalelements('Group of 5'())
totalelements
(group 1)
Button3
2say 'Group 2 count:' totalelements('Group of 6'())
totalelements
(group 2)
"totalelements"
	"gettype"
type = GETTYPE (arg)
eturn one of these strings: 
Drawing
Picture
Button
Group
, depending on the type of the argument.
Button1
/* Get a screen position, announce the type of object there. */
bj = GetObject('Click on object/page to find its type...')
f length(obj) = 0
   then obj = ':'
ay 'Type is:' gettype(obj)
Group1
Note1
Picture1
hdat:
Note2
Button1
Button
Drawing1
List1
	"gettype"
	"getpage"
pg = GETPAGE (arg)
eturn the objnum of the page to which 
 pertains.
Button1
say 'My page is:' getpage(initiator())
	"getpage"
	"getnext"
next = GETNEXT (arg)
 is a page or an item, the returned value 
 is the objnum of
the next page or item. If 
 is an object, 
 is the objnum of the
next object in a depth-first search of the page, or the first object on
the next page if there are no more objects on the current page. An
empty objnum is returned if the end of the list in 
's category has
been reached.
Button1
/* list all objects on page 50 */
ob = '50:1'
o while getpage(ob) = '50:'
   say ob '-' getname(ob)
   ob = getnext(ob)
   end
	"getnext"
	"getnext"
next = GETNEXTSIB (arg)
 is a page or an item, the returned value 
 is the objnum of
the next page or item. If 
 is an object, 
 is the objnum of the
next object at the same level as the given one (i.e. without descending
 is a group), or the empty string if there are no more objects
's list.
Button1
/* list level 1 objects on page 50
ob = objectnumber('50:',1)
o while ob ~= ''
   say ob '-' getname(ob)
   ob = getnextsib(ob)
   end
"getnextsib"
"objectnumber"
obj = OBJECTNUMBER (arg, num)
eturn the objnum of the object/item whose sequence number on the
given (page or group)/list is 
. The empty string is returned if the
sequence number is invalid. If 
 is the empty string, return the
objnum of page 
"Script"
/* Say objnums/names of objects on page */
n=totalelements(':')
o i=1 to n
o=objectnumber(':',i)
say 'Object' o || ', name =' getname(o)
"Framed boxes"
"Frame"
"Five boxes"
	"Red box"
"Four boxes"
"Blue box"
"Three boxes"
"Purple box"
"Two boxes"
"Green box"
"Black box"
"objectnumber"
"parent"
parent = PARENT (arg)
eturn the objnum of the page, bin, group or list one
level up from the given object or item.
Button1
say 'My parent is' parent(initiator())
"parent"
"currentpage"
page = CURRENTPAGE ()
eturn the objnum of the current page
Button1
say 'Current page =' currentpage()
"currentpage"
"initiator"
obj = INITIATOR ()
eturn the objnum of the object or item that launched
the current macro or ARexx command. Return the
empty string if the macro or command was not
launched by an object or item (e.g. from a menu).
Button1
say 'My objnum is "' || initiator() || '"'
"initiator"
	"ismacro"
bool (1 or 0) = ISMACRO (name)
eturn 1 if the given name is that of a macro in the
current hyperbook, and 0 otherwise. (A zero result does
not preclude the possibility that the macro may be
available to be executed from disk.)
Button1
m = ismacro('FindAction')
n = ismacro('MindAction')
not.0 = 'not a'
not.1 = 'a'
say "`FindAction' is" not.m "macro."
say "`MindAction' is" not.n "macro."
	"ismacro"
"movemacro"
MOVEMACRO (macroname, newpos)
ove the named macro to position 
newpos
the macro list, which is displayed by several
selections in the 
ARexx
 menu. If the given
position is less than or equal to zero, the
macro is moved to the end of the list.
Button1
/* Examine Macro list after... */
call movemacro('ExecuteText', 1)
Button2
/* ... and again after... */
call movemacro('ExecuteText', 14)
"movemacro"
"interactive"
oldstate = INTERACTIVE (bool)
et (1) or clear (0) interactive mode, and return its
previous state. In interactive mode, objects are updated
on-screen after each operation. Otherwise, objects are
updated only: when REFRESHLIST or REFRESHPAGE is used;
on re-entering interactive mode explicitly (with the
present function); on exiting a command or macro to
interactive operation. Commands and macros always
start in interactive mode.
Note2
The macro 
INTERACTIVE demo
 colors the top half of the list at right with
interactive mode on, and the bottom half with interactive mode off.
Button1
I call "INTERACTIVE demo"
Group1
Note1
"interactive list"
hydrogen
helium
lithium
	beryllium
boron
carbon
nitrogen
oxygen
fluorine
sodium
	magnesium
"interactive"
"pause"
PAUSE (tenths)
ause program execution for the given number of
tenths of seconds.
"Pause demo"
call beginprompt("Pausing for 1 1/2 seconds...")
call pause(15)
"pause"
"inform"
INFORM (string)
isplay the given string, and wait for the user to click Okay.
Button1
call inform(' This is an informative message. ')
"inform"
"rand"
value = RAND (low, high)
eturn a pseudo-random integer between 
 and 
, inclusive. Unlike
ARexx's RANDOM function, RAND does not need to be reseeded for each
script.
"Rand demo"
call beginprompt('Generating random numbers...')
tx = '0a'X
o i = 1 to 10
   do j = 1 to 10
      tx = tx right(rand(1,1000),4)
      end
  tx = tx || '0a'X
   end
all inform(tx)
"rand"
diamond.font
diamond.font
