6/* When an edit button is pressed, this macro is called. */
btn = initiator()
num  = sequencenumber(btn)
se   = searchpagename('1:', 'Self-Expression')
fe   = searchname(':', 'Finished editing')
list = searchname(se, 'Phrase' num || '.')
se   = parent(list)
left   = getleft(list)
top    = gettop(list)
width  = getwidth(list)
height = getheight(list)
pg = searchpagename(':','Phrase List page')
call setposition(list, 40, 20)
call scaletosize(list,480,120)
list = relocate(list, pg)
newfe = searchname(pg, 'Finished Editing')
cmd1 = "pl=relocate(searchname(':','Phrase'),'" || se || "');"
cmd2 = "call return();"
cmd3 = "call scaletosize(pl," || width || "," || height || ");"
cmd4 = "call setposition(pl," || left || "," || top || ");"
call setactionrexx(newfe, cmd1 || cmd2 || cmd3 || cmd4)
call callpage(pg)
Edit phrase
v/* Create memorable prose passage from phrases in 25 lists */
call beginprompt('Please wait... making up memorable prose')
if length(searchname(':', 'Phrases')) == 0 then do
   say "Can't find group containing phrase text."
   EXIT
   end
note = searchname(':', 'Memorable prose')
if length(note) == 0 then do
   note = createnote()
   call setname(note, 'Memorable prose')
   call scaletosize(note, 640, 190)
   call setposition(note,   0,   0)
   end
else do
   note = relocate(note, '0:')
   call cleartext(note)
   end
call rand(1,100)
call inserttext(note, 'Waiting alone in the' randomitem(1), -1)
call inserttext(note, ',' 'with the' randomitem(2), -1)
call inserttext(note, ' wafting in from outside,' randomitem(3), -1)
call inserttext(note, ' thought once more of' randomitem(4), -1)
call inserttext(note, ',' 'the' randomitem(5), -1)
call inserttext(note, '.' 'He was now, according to' randomitem(6), -1)
call inserttext(note, ',' randomitem(7) || '.' || '0a0a'x, -1)
call inserttext(note, 'Then came' randomitem(8), -1)
call inserttext(note, ',' 'and she' randomitem(9), -1)
call inserttext(note, '.' 'He was here! "' || randomitem(10), -1)
call inserttext(note, ',' randomitem(11), -1)
call inserttext(note, '!"' 'he' randomitem(12), -1)
call inserttext(note, ',' randomitem(13), -1)
call inserttext(note, ',' 'and as' randomitem(14), -1)
call inserttext(note, ',' 'she' randomitem(15) || '.' || '0a'x, -1)
call endprompt()
call interactive(0)
call objecttoback(relocate(note,':'))
return
randomitem: procedure
   list = searchname(':','Phrase' arg(1) || '.')
   return getitemtext(objectnumber(list, rand(1,numelements(list))))
Create Prose
Note1
"Romance"
The AHA! Romance Novel Generator
Note2
This notebook will generate two paragraphs of text in the style of a
pulp romance novel.
Turn to the next page to read an example, then click on the "Write
new text" to generate a new story. You can generate new text any
number of times - no two are alike!
To add to or modify the database of phrases, turn to the page after
next, where you'll see an example of prose in the standard style. The
parts of the text contained in the database are underlined; click on
one of these to view the list and modify it. There are 15 sets of
these phrases, each stored in an invisible List.
Group1
Drawing1
Button1
Continue
"Introduction"
8elp.txt
"Memorable prose"
Waiting alone in the quiet chapel where they had first met, with the
sprightly piping of the Vicar's flageolet wafting in from outside, the
terrified Violetta thought once more of Doctor Ken, the bold bandito
who had been so gentle in her arms. He was now, according to
Countess Genevieve, dancing away the hot Rio nights with the sultry
Sophia.
Then came the sound of her own name being called, and she dropped
the brimming wine glass heedlessly on the rug. He was here! "I've
thought of you every minute I've been away, you sweet little morsel of
girl-flesh!" he said quietly, sweeping her into his arms, and as he
went down on his knees and implored her to forgive him, she
wordlessly let her body melt against his own.
Button1
Write new text
	"Phrases"
"Phrase 9."
whirled around
gasped
nearly swooned
5dropped the brimming wine glass heedlessly on the rug
4felt her heart suddenly beat with a new, wild rhythm
4somehow knew that her heart had been right all along
3shut her eyes tight for one moment of silent prayer
5leapt to her feet with hope - and alarm - in her eyes
%instinctively checked her fingernails
'struggled in vain with her sudden panic
rose to face the inevitable
5realized, in a single instant, what was now to happen
"Phrase 11."
my darling
you little fool
sweetheart
my angel - my porcelain angel
beloved
%you sweet little morsel of girl-flesh
my perfect little carrot
	baby doll
my dewy, doll-faced delight
	honey bun
my Oriental pearl
Adored One
my giddy little goose
"Phrase 10."
Kiss me
Come to me
I couldn't stay away
/I've thought of you every minute I've been away
Our love will outlast eternity
There's only ever been you
We marry tonight
I worship you
Without you I am nothing
%I tried to forget you, but I couldn't
All I have is yours
.Even the crafty Luiz couldn't keep me from you
"Phrase 13."
sweeping her into his arms
pressing his lips to hers
flexing his sweaty biceps
-blowing a perfect smoke ring in her direction
&nervously adjusting his artificial leg
"signalling his porters to withdraw
$his eyes alive in the slanting light
,oblivious of the lava-red eyes at the window
)tilting her oval face up to meet his lips
$passion igniting his strong features
.drawing her to him as a moth to a lantern wick
.setting her aglow with the heat of his passion
"Phrase 15."
Cknew that at last he was hers - and that only death could part them
7began to wonder how she would explain all this to Colin
:started to think about what they would call their children
@made a mental note to call Mitzi later and tell her all about it
,wordlessly let her body melt against his own
3woke up. Incredibly enough, it had all been a dream
Htook a moment to plan some of the details of their pre-nuptial agreement
Swondered if this would be a good time to remind him about the books he had borrowed
Gallowed her willing mind to sink into a rose-colored maelstrom of bliss
>vowed never again to do anything spiteful, foolish or immature
Prealized thankfully that, in the end, things always work out really, really well
Oat last understood that for the two of them, life was only now really beginning
"Phrase 12."
chuckled
breathed
:said with his eyes (for his voice was now silent for ever)
said in his halting Spanish
boomed
intoned
blurted
husked
-murmured in that unforgettable hypnotic drawl
said simply
said quietly
	stammered
"Phrase 14."
the band began to play
;the music in her heart rose to a new crescendo of happiness
:the horror of these last months vanished in a blaze of joy
Jthe glow of renewed love gradually overcame her mounting desire for dinner
'he slid the little ring onto her finger
9he went down on his knees and implored her to forgive him
6it dawned on her that her days of loneliness were over
5the truth - the whole truth - slowly come home to her
Ihe dabbed at her tears with the handkerchief she herself had made for him
Ihe excitedly began to show her his plans for the villa they were to share
Ihe once again began to woo her with the sensual voice of his Stradivarius
"Phrase 4."
Edwin
	Long John
Lyle `Sneaky Legs' Malone
Doctor Ken
"former U.S. President Jimmy Carter
Reginald Fortescue
Baron Otto
the Chief's handsome son
young Simon
the fearless Francisco
tall Trader Tom
the `Parisian Pirate', Pierre
Senator Sam
dashing David DeFoe
"Phrase 6."
father
Brother Boris
	The Times
persistent rumours
Countess Genevieve
the gypsy woman
the best salon gossip
his scheming partner, Reg
that television program
three independent witnesses
her horoscope
the letter on the bureau
the message on the dagger
Roger's shocking revelation
"Phrase 5."
"only man she had ever really loved
&mysterious stranger with the large dog
"one person left who could help her
'`hooded visitor' in her recurring dream
"man who had taught her how to feel
Jmasterful tutor who had transformed her from a mere girl into a real woman
2loving suitor she had turned so thoughtlessly away
%man she had belonged to so completely
/bold bandito who had been so gentle in her arms
Csensitive genius who had known her in ways even she did not suspect
<brilliant scholar who had wanted to make her his life's work
(soldier-lover of her youthful imaginings
"Phrase 2."
'scent of almond blossoms and frangipani
 cries of the frolicking children
faint traffic hum
shouts of the street hawkers
rank odour of decay
smell of new-cut grass
fragrance of a new spring
%far-off clamour of the playing fields
)sprightly piping of the Vicar's flageolet
%plaintive braying of the Don's llamas
$rhythmic strumming of Pedro's guitar
sweet orchard smell
aroma of fresh mulberry pies
"Phrase 7."
'lost forever in the wilds of the Amazon
.struggling for life in the intensive care ward
;in the clutches of Cesar Marquez and his gang of cutthroats
6dancing away the hot Rio nights with the sultry Sophia
#prospecting for silver in the Andes
away again on safari
2the hapless captive of mind-devouring space aliens
3marooned by his own crew on the Isle of Retribution
/a prisoner in the very castle he had once owned
2starring in yet another film with F
lice Contraire
2recklessly endangering her life as well as his own
<drinking himself to death in the company of the hateful Luiz
2on a collision course with the High Council itself
+seeking a new life as a Foreign Legionnaire
"Phrase 3."
the frightened girl
Mindy West, Student Nurse,
Serena
the still-proud Princess
Lady Pamela
the softly-sobbing Clarissa
the wholly heartbroken Heather
4Belinda, even lovelier - if possible - in her grief,
the terrified Violetta
the twice-jilted Juliet
-Alicia - she who had always seemed so cold! -
"Phrase 8."
a knock at the door
a sudden clatter of hooves
/an abrupt fanfare from the long-silent trumpets
a peal of mighty bells
&the sound she had been longing to hear
1a confused chorus of greetings from the courtyard
a flurry of activity
&the sound of her own name being called
/a sudden commotion, heavy footsteps in the hall
0an inrush of cool air as the door was flung open
an eerie chill of premonition
:the thud of fists, a muffled cry, fighting on the stairway
"Phrase 1."
great, oak-panelled library
chill gloom of the crypt
!humble comfort of old Ben's hovel
)now-familiar confines of Maku's grass hut
&gleaming, antiseptic operating theatre
%quiet chapel where they had first met
little walled garden
6study, by the fiercely-staring portrait she so loathed
1room where Constance had witnessed the apparition
0secret alcove they had both come to know so well
+Red Chamber, remembering its bloody history
(frost-blue frock he had so often praised
%midst of her uncle's grotesque curios
+full knowledge that her fate was now sealed
Group2
Drawing1
Button1
Intro
Group3
Drawing1
Button1
Edit phrases
"Self-Expression"
"Finished editing"
qpl=relocate(searchname(':','Phrase'),'2:5');call return();call scaletosize(pl,200,80);call setposition(pl,15,15);
Finished editing
Group1
Note1
Click on a red word or phrase in the above example to
modify the built-in list of words and phrases
Drawing1
"WriteText"
Write text
Group2
"Memorable prose"
Waiting alone in the
library
, with the
scent of flowers
wafting in from outside,
 thought once more of
Harold
, the
debonair lounge singer
, now, according to
Maurice
away skiing in Austria
Then came 
a rapping at the door
, and she
jumped up
He was here! "
Kiss me
my love
!" he 
whispered
drawing her close
, and as 
the sun slowly set
, she
realized that he really did love her
Group1
Button1
Button2
Button3
Button4
Button5
Button6
Button7
Button8
Button9
Button10
Button11
Button12
Button13
Button14
Button15
"Edit phrases"
"Finished editing"
rpl=relocate(searchname(':','Phrase'),'2:3');call return();call scaletosize(pl,200,80);call setposition(pl,139,34);
Finished editing
Note1
(Hold down the SHIFT key and double-click on
the above list to edit the phrases. After
editing, click the button on the left.) 
"Phrase List page"
h:wbstuff/dpaint
TransEdit -k1
garnet.font
garnet.font
